#!/usr/bin/env python
# -*- coding: Latin-1 -*-
import user
import os
from xml.dom import minidom
from dcopamarok import dcop_amarok


# the fields to be shown via http
FIELDS = ("URL","Path","Artist", "Title", "Album", "TrackNo", "Length", "Genre",  "Score" )


class PlaylistTrack(object):
    """Class that holds the information of one track in the current playlist"""
    __slots__ = FIELDS

    def __init__(self, **kwargs):
        for key,value in kwargs.iteritems():
            setattr(self, key, value)


class CurrentPlaylist:
    """The Playlist class represents the Playlist as one object. It holds all
    needed information and does most of the work"""

    def __init__(self):
        """The Constructor takes no arguments."""
        self.pathname = dcop_amarok("playlist","saveCurrentPlaylist")
        self.tracks = []
        self.mtime = None
        self.reread()

    def has_changed(self):
	    if self.mtime != os.stat(self.pathname)[-2]: return True
	    return False

    def reread(self):
	    dcop_amarok("playlist","saveCurrentPlaylist")
	    if self.has_changed():
		    import logging
		    logging.getLogger(str(self.__class__)).debug("Changed: rereading")
		    self.mtime = os.stat(self.pathname)[-2]
		    self._buildDoc()

    def _buildDoc(self):
        """Build the DOM-doc and calls the _extractTracks-Method"""
	self.doc = minidom.parse(self.pathname)
        self._extractTracks()

    def _extractTracks(self):
        self.tracks = []
        append = self.tracks.append
        for item in self.doc.getElementsByTagName("item"):
            curTrack = PlaylistTrack()
            for elem in FIELDS:
                try:
                    value = item.getElementsByTagName(elem)[0].firstChild.nodeValue
                except:
                    value = '  '
                setattr(curTrack, elem, value)    
            url = item.getAttribute("url")
	    setattr(curTrack,"URL",url)
	    if url.startswith("file://"):
	    	from urllib import url2pathname,unquote
	    	path = unquote(url[7:].encode("ascii")) # stupid workaround, shit!
	    	setattr(curTrack,"Path",path)
	    else:
	    	setattr(curTrack,"Path",None)
            append(curTrack)


